from osgeo import ogr

def clone_or_append_tables_with_prefix():
    input_geopackages = ["c:/testgpkgV2/pointsENC.gpkg", "c:/testgpkgV2/linesENC.gpkg", "c:/testgpkgV2/polysENC.gpkg"]
    prefixes = ["pt_", "li_", "pl_"]
    
    for i in range(len(input_geopackages)):
        # Ouvrir le GeoPackage source en mode lecture
        input_gpkg = ogr.Open(input_geopackages[i], 0)

        if input_gpkg is not None:
            # Ouvrir le GeoPackage de destination en mode écriture
            output_gpkg = ogr.Open("c:/testgpkgV2/ENC5.gpkg", 1)
            prefix = prefixes[i]

            if output_gpkg is not None:
                # Récupérer le nombre de tables dans le GeoPackage source
                num_tables = input_gpkg.GetLayerCount()

                # Ajouter le contenu des tables avec le préfixe approprié
                for j in range(num_tables):
                    input_table = input_gpkg.GetLayerByIndex(j)
                    output_table_name = f"{prefix}{input_table.GetName()}"
                    input_table_name = input_table.GetName()

                    # Vérifier si la table de destination existe déjà
                    output_table = output_gpkg.GetLayerByName(output_table_name)
                    if output_table is None:
                        # Créer une nouvelle couche de destination si elle n'existe pas
                        output_table = output_gpkg.CreateLayer(output_table_name, geom_type=input_table.GetGeomType(), options=["OVERWRITE=YES"])

                        # Copiez la structure de la table d'origine vers la table temporaire
                        input_layer = input_gpkg.GetLayerByName(input_table_name)
                        input_layer_defn = input_layer.GetLayerDefn()

                        for k in range(input_layer_defn.GetFieldCount()):
                            field_defn = input_layer_defn.GetFieldDefn(k)
                            output_table.CreateField(field_defn)

                    # Copier les entités de la table source vers la table de destination
                    for feature in input_table:
                        output_feature = ogr.Feature(output_table.GetLayerDefn())
                        output_feature.SetGeometry(feature.GetGeometryRef())

                        # Copier les valeurs des champs
                        for field_index in range(feature.GetFieldCount()):
                            output_feature.SetField(field_index, feature.GetField(field_index))

                        output_table.CreateFeature(output_feature)
                        output_feature = None  # Libérer la mémoire

                    print(f"Contenu ajouté de {input_geopackages[i]}.{input_table.GetName()} vers ENC.gpkg.{output_table_name}")

                # Fermer les GeoPackages
                input_gpkg = None
                output_gpkg = None
            else:
                print(f"Impossible d'ouvrir le GeoPackage {output_geopackage} en mode écriture.")
        else:
            print(f"Impossible d'ouvrir le GeoPackage {input_geopackages[i]} en mode lecture.")

# Appel de la fonction append_tables_with_prefix
clone_or_append_tables_with_prefix()
